/*****************************************************************************
This is a Pattern Recognition program
Copyright (C) 2006  Elmar Sack

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Elmar.Sack@mnet-online.de
*****************************************************************************/

/* global prototypes *******************************************************/
int xscan_bmp(sector_def clip, c_def *c, pic_def pic, PICT mark, 
	      int *init_scan, int bot_up);
int mark_diff(pic_def src, pic_def dst, area_def cut, int sx, int sy,
	      int dx, int dy, int mark);
void rlft2(double **data, double *speq, ulong nn2, ulong nn3, int isign);
void corr2d(fft_def fd1, fft_def fd2, int pre_fd1_fft, int pre_fd2_fft);
int overlapping_degree(pic_def pica, pic_def picb, int lx, int ly);
void dilate_in_box(pic_def pic);
cv_def_i masked_correlation_ext(pic_def ref, pic_def mask, sector_def rbs, 
			        sector_def rbse, pic_def pic, double msm,
			        int mask_border, int noise_border, 
				double corrlevel);
int wtd_correlation_ext(pic_def ref, pic_def mask, sector_def rbs, 
			sector_def rbse, pic_def pic, int lx, int ly);
cv_def wtd_correlation(pic_def ref, pic_def mask, sector_def rbs, 
		       pic_def pic, int lx, int ly);
h_contour_lst xgen_h_contour(pic_def pic, sector_def fr, PICT search, 
			     int bot_up, int n4);
h_contour_lst xgen_h_contour_from_start(pic_def pic, sector_def fr, 
				       c_def start, int n4);
int pic_mass(pic_def src, area_def cut, int sx, int sy);
double mean_value_d(double *in, int cnt, int suppress, int sval);
double standard_deviation(int *in, int cnt, double mv, int suppress, 
			  int sval);
cv_def_f cv_def_f_mean_value(cv_def_f *in, int cnt, int skip);
cv_def_f cv_def_f_variance(cv_def_f *in, int cnt, cv_def_f mv, int skip);
double euclid(double x, double y);
cv_def_f cv_def_i_mean_value(cv_def_i *in, int cnt, int skip);
cv_def_f cv_def_i_variance(cv_def_i *in, int cnt, cv_def_f mv, int skip);
cv_def_i full_correlation1(pic_def ref, pic_def pic, run_def *crun);
cv_def_i masked_correlation_abbrev(pic_def ref, pic_def mask, sector_def rbs,
				  pic_def pic, double msm, int mask_border,
				  int noise_border, double corrlevel);
double mean_value(int *in, int cnt, int suppress, int sval);
double mean_value_double(double *in, int cnt);
void realft(double data[], ulong n, int isign);
fft_def psd_of_double_lst(double_lst lst);
fft_def autocorrelation_of_double_lst(double_lst lst);
fft_def crosscorrelation_of_double_lst(double_lst alst, double_lst blst);
double sum_of_square(double *a, double *b, int cnt);
double_lst distribution(hst_def hst);
hst_def threshold_otsu(double_lst dst);
hst_def slope_mean(pic_def pic, int cnt);
pic_def xcopy_masked_area(pic_def ref, pic_def mask, sector_def rbs, 
			  pic_def pic, pic_def org, int lx, int ly, 
			  kern_def kernel, int cluster_thold);
void erase_masked_area(pic_def ref, pic_def mask, sector_def rbs, pic_def pic,
		       pic_def org, int lx, int ly);
double power_of_signal(double_lst signal);
int_lst relax_list(int_lst ilst, double dt, int iteration);
c_def scan_bmp_masked(pic_def mask, sector_def rbs, pic_def pic,
		      int lx, int ly);
int correlation_features_1D(double_lst alst, double_lst blst, fft_def corrf,
			    ival_def *positive_lag, ival_def *redundant_lag, 
			    ival_def *negative_lag);
int pixel_erase(pic_def pic, NBH nbh, int support_dots);
int erode_in_box(pic_def pic);
pic_def scale_down_image(pic_def source_img, area_def dest_ar, 
			 gboolean has_aspect);
void xplab_scale_down_image(pic_def source_img, pic_def dest_img, 
			    gfloat src_start_x, gfloat src_start_y, 
			    gfloat magnitude);
void xplab_scale_up_image(pic_def source_img, pic_def dest_img, 
			  gfloat src_start_x, gfloat src_start_y, 
			  gfloat magnitude, int netto_x, int netto_y);
hst_def histogram_8bit(PICT *img_buf, area_def bsize);
void histogram_rgb(col_def *img_buf, area_def bsize, hst_def *hred, 
		   hst_def *hgreen, hst_def *hblue);
hst_def histogram_auto(int *val, int anzahl);

/***************************************************************************/
